@REM ******************************************************************************
@REM * FILE NAME: create_sd.bat
@REM *
@REM * DESCRIPTION:
@REM *  This script file parses the .out executables generated by the diagnostic
@REM *  makefile into SD card loadable files.
@REM *
@REM *  The script expects the board as a parameter. Out2rprc and MulitcoreImageGen
@REM *  can be set manually by environment variables %OUT2RPRC% and 
@REM *  %MULTICOREIMAGEGEN%, respectively. If not set, script will assume default
@REM *  location in %PDK_INSTALL_PATH%/ti/boot/sbl/tools
@REM *
@REM *  Syntax:
@REM *      create_sd.bat [BOARD]
@REM *
@REM *  Example:
@REM *      create_sd.bat idkAM572x
@REM
@REM * Copyright (C) 2015, Texas Instruments, Inc.
@REM *****************************************************************************

@echo off
set board=%1

IF "%board%" == "evmAM335x" (
echo Done! create_sd script not needed for %board%
goto :end
)

IF "%board%" == "evmAM437x" (
echo Done! create_sd script not needed for %board%
goto :end
)

IF "%board%" == "idkAM437x" (
echo Done! create_sd script not needed for %board%
goto :end
)

IF "%board%" == "skAM437x" (
echo Done! create_sd script not needed for %board%
goto :end
)

IF "%board%" == "bbbAM335x" (
echo Done! create_sd script not needed for %board%
goto :end
)

IF "%board%" == "icev2AM335x" (
echo Done! create_sd script not needed for %board%
goto :end
)

IF "%board%" == "skAM335x" (
echo Done! create_sd script not needed for %board%
goto :end
)

IF "%board%" == "evmK2H" (
set core_id=5
)

IF "%board%" == "evmK2E" (
set core_id=5
)

IF "%board%" == "iceK2G" (
set core_id=5
)

IF "%board%" == "evmK2G" (
set core_id=5
)

IF "%board%" == "evmAM572x" (
set core_id=8
)

IF "%board%" == "evmAM571x" (
set core_id=8
)

IF "%board%" == "idkAM574x" (
set core_id=8
)

IF "%board%" == "idkAM572x" (
set core_id=8
)

IF "%board%" == "idkAM571x" (
set core_id=8
)

set benchmarkdir=%PROC_SDK_INSTALL_PATH%/demos/audio-benchmark-starterkit
IF EXIST %benchmarkdir%/prebuilt-binaries (
echo Creating SD files for %board%...
) ELSE (
echo Missing folder/files under %benchmarkdir%/prebuilt-binaries
echo Usage: create_sd.bat [BOARD]
echo     Eg. create_sd.bat idkAM572x
goto :err
)

set sbl_sd=%PDK_INSTALL_PATH%/ti/boot/sbl/binary/%board%/mmcsd/bin/MLO
IF NOT EXIST %sbl_sd% (
	echo 
	echo Missing MLO built from bootloader source
	echo Not found in default location: 
	echo %%PDK_INSTALL_PATH%%/ti/boot/sbl/binary/%board%/mmcsd/bin/MLO
	echo Looking for pre-built binary....
) ELSE (
	echo Using MLO: %sbl_sd%
	goto :tools_setup
)

set sbl_sd=%PROC_SDK_INSTALL_PATH%/prebuilt-sdcards/%board%/sd_card_files/MLO
REM %PDK_INSTALL_PATH%/ti/boot/sbl/binary/%board%/mmcsd/bin/MLO
IF NOT EXIST %sbl_sd% (
	echo 
	echo Missing prebuilt MLO
	echo Not found in default location: 
	echo %%PROC_SDK_INSTALL_PATH%%/prebuilt-sdcards/%board%/sd_card_files/MLO
	echo Change Directory to %%PDK_INSTALL_PATH%%/ti/boot/sbl
	echo Run gmake all BOARD=%board% SOC=%SOC% BOOTMODE=mmcsd
	goto :err
) ELSE (
	echo Using MLO: %sbl_sd%
	goto :tools_setup
)

:tools_setup
set out2rprc=%OUT2RPRC%
IF [%out2rprc%] == [] (
	set out2rprc=%PDK_INSTALL_PATH%/ti/boot/sbl/tools/out2rprc/bin/out2rprc.exe
)
IF NOT EXIST %out2rprc% (
	echo Missing out2rprc!
	echo     Not found in default location: %%PDK_INSTALL_PATH%%/ti/boot/sbl/tools/out2rprc/bin/out2rprc.exe
	echo     Override default location by setting OUT2RPRC, eg:
	echo         set OUT2RPRC=%PDK_INSTALL_PATH%/ti/boot/sbl/tools/out2rprc/bin/out2rprc.exe
	goto :err
) ELSE (
	echo Using out2prc: %out2rprc%
)

set multigen=%MULTICOREIMAGEGEN%
IF [%multigen%] == [] (
	set multigen=%PDK_INSTALL_PATH%/ti/boot/sbl/tools/multicoreImageGen/bin/MulticoreImageGen.exe
)
IF NOT EXIST %multigen% (
	echo Missing multigen!
	echo     Not found in default location: %%PDK_INSTALL_PATH%%/ti/boot/sbl/tools/multicoreImageGen/bin/MulticoreImageGen.exe
	echo     Override default location by setting MULTICOREIMAGEGEN, eg:
	echo         set MULTICOREIMAGEGEN=%PDK_INSTALL_PATH%/ti/boot/sbl/tools/multicoreImageGen/bin/MulticoreImageGen
	goto :err
) ELSE (
	echo Using multigen: %multigen%
)

set sd_dir=%benchmarkdir%/prebuilt-binaries/bootimages/%board%
md "%sd_dir:/=\%"
PUSHD  %CD%
cd %benchmarkdir%/prebuilt-binaries
for %%f in (*.out) do call :Parse %%f
goto :loopend
:Parse
set out=%1
echo Parsing %out%
for /f "tokens=1 delims=." %%a in ("%out%") do set name=%%a
set rprc=%sd_dir%/%name%_rprc
%out2rprc% %out% %rprc%
%multigen% LE 55 %sd_dir%/%name%_app %core_id% %rprc%
goto :end
:loopend
cd %sd_dir%
del *_rprc
cp %sbl_sd% .
POPD
goto :success

:err
echo Error encountered while running!
goto :end

:success
echo Done! Check %sd_dir% for images to put onto SD card.

:end
